package eu.lucazanini.restoreobject.customobject;

import android.os.Parcel;
import android.os.Parcelable;

public class CustomParcelableObjectWrapper implements Parcelable {

    public static final Parcelable.Creator<CustomParcelableObjectWrapper> CREATOR = new Parcelable.Creator<CustomParcelableObjectWrapper>() {
	@Override
	public CustomParcelableObjectWrapper createFromParcel(Parcel in) {
	    return new CustomParcelableObjectWrapper(in);
	}

	@Override
	public CustomParcelableObjectWrapper[] newArray(int size) {
	    return new CustomParcelableObjectWrapper[size];
	}
    };

    private CustomParcelableObject[][] array;

    public CustomParcelableObjectWrapper(String name) {
	array = new CustomParcelableObject[3][3];
	for (int i = 0; i < 3; i++) {
	    for (int j = 0; j < 3; j++) {
		array[i][j] = new CustomParcelableObject(name + " at " + i
			+ ", " + j);
	    }
	}
    }

    private CustomParcelableObjectWrapper(Parcel in) {
	array = (CustomParcelableObject[][]) in
		.readArray(CustomParcelableObjectWrapper.class.getClassLoader());
    }

    @Override
    public int describeContents() {
	return 0;
    }

    public CustomParcelableObject getCustomParcelableObject(int i, int j) {
	return array[i][j];
    }

    public void setCustomParcelableObject(int i, int j, String name) {
	array[i][j].setName(name);
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
	dest.writeArray(array);
    }

}
